<?php
// add a hook to inject code to woocommerce's CompleteRegistration event
add_action( 'woocommerce_created_customer', 'trackman_add_fb_pixel_to_complete_registration' );

// inject code to woocommerce's CompleteRegistration event
function trackman_add_fb_pixel_to_complete_registration( $customer_id ) {

    // create a cookie called "trackman_completeregistration" to prevent duplicate event
    // expires in 1 hour
    setcookie("trackman_completeregistration", "1", time() + 3600, "/");
    // if the cookie exists, do not send the event
    if (isset($_COOKIE['trackman_completeregistration'])) {
        return;
    }

	// skip this if options 'trackman_woocommerce_autosend' is false or null
	if( get_option( 'trackman_woocommerce_autosend' ) == false || get_option( 'trackman_woocommerce_autosend' ) == null ) {
		return;
	}

	?>
	<script type="text/javascript">
		window.fbq = window.fbq || function () {
			fbq.callMethod ? fbq.callMethod.apply(fbq, arguments) : fbq.queue.push(arguments);
		};
		if (!window._fbq) window._fbq = window.fbq;
		window.fbq.push(['track', 'CompleteRegistration']);
	</script>
	<?php
}