<?php

// = woocommerce
add_action( 'wp', 'trackman_add_fb_pixel_to_woof_thankyou' );
add_action( 'wp', 'trackman_add_fb_pixel_to_wooc_thankyou' );

function trackman_add_fb_pixel_to_woof_thankyou() {

	// if get_woocommerce_currency() function is not available, return
	if( !function_exists('get_woocommerce_currency') ) return;

	if( !isset($_GET['order_id']) ) return false;

	// Get the current URL
    $current_url = $_SERVER['REQUEST_URI'];

    // Check if the URL contains "/order-confirmed"
    if (strpos($current_url, '/order-confirmed') === false) {
        return false;
    }

	$order_id = $_GET['order_id'];

	if( is_order_from_woofunnels($order_id) ) {
		$step_id = is_order_from_woofunnels($order_id);
		global $wpdb;
		$table_name = $wpdb->prefix . 'bwf_funnels';
		$result = $wpdb->get_results("SELECT * FROM {$table_name} WHERE steps LIKE '%:{$step_id}%'", ARRAY_A);
		if( !$result ) return;
		$result = $result[0];
		$funnel_id = $result['id'];
		$value_arr = get_option( 'trackman_wf_public_keys' );
		$public_keys_arr_string = $value_arr[$funnel_id];
		$trackman_public_keys_array = explode(',', $public_keys_arr_string);
		// $value_arr = get_option( 'trackman_wf_public_keys' );
		// $public_keys_arr_string = $value_arr[$funnel_id];
		// $trackman_public_keys_array = explode(',', $public_keys_arr_string);
	} else {
		$trackman_public_keys_array = explode( ',', get_option( 'trackman_public_key' ) );
		// skip this if options 'trackman_woocommerce_autosend' is false or null
		if( get_option( 'trackman_woocommerce_autosend' ) == false || get_option( 'trackman_woocommerce_autosend' ) == null ) {
			return;
		}
	}

	// if the cookie exists, do not send the event
	if (isset($_COOKIE['trackman_purchase_'.$order_id])) {
		return;
	}

	// get order object
	$order = wc_get_order( $order_id );
	$firstname = $order->get_billing_first_name() ? $order->get_billing_first_name() : $order->get_shipping_first_name();
	$lastname = $order->get_billing_last_name() ? $order->get_billing_last_name() : $order->get_shipping_last_name();
	$email = $order->get_billing_email();
	$phone = $order->get_billing_phone();
	$city = $order->get_billing_city() ? $order->get_billing_city() : $order->get_shipping_city();
	$state = $order->get_billing_state() ? $order->get_billing_state() : $order->get_shipping_state();
	$postcode = $order->get_billing_postcode() ? $order->get_billing_postcode() : $order->get_shipping_postcode();
	$country = $order->get_billing_country() ? $order->get_billing_country() : $order->get_shipping_country();
	$address = $order->get_billing_address_1() ? $order->get_billing_address_1() : $order->get_shipping_address_1();
	$address2 = $order->get_billing_address_2() ? $order->get_billing_address_2() : $order->get_shipping_address_2();
	$order_total_as_float = floatval($order->get_total());

	$eventData = [
		'event_name' => 'Purchase',
		'event_time' => time(),
		"action_source" => "website",
		"opt_out" => false,
		'event_source_url' => $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'],
		'user_data' => [
			'client_ip_address' => $_SERVER['REMOTE_ADDR'],
			'client_user_agent' => $_SERVER['HTTP_USER_AGENT'],
			'fn' => $firstname,
			'ln' => $lastname,
			'em' => $email,
			'ph' => $phone,
			'ct' => $city,
			'st' => $state,
			'zp' => $postcode,
			'country' => $country
		],
		'custom_data' => [
			'content_name' => 'Purchase',
			'content_category' => 'ecommerce',
			'content_ids' => '',
			'content_type' => 'product',
			'currency' => get_woocommerce_currency(),
			'value' => $order_total_as_float,
			'num_items' => $order->get_item_count(),
		]
	];

    // loop through $eventData into every level and remove null values
    foreach ($eventData as $key => $value) {
        if (is_array($value)) {
            foreach ($value as $key2 => $value2) {
                if (is_array($value2)) {
                    foreach ($value2 as $key3 => $value3) {
                        if (is_null($value3)) {
                            unset($eventData[$key][$key2][$key3]);
                        }
                    }
                } else {
                    if (is_null($value2)) {
                        unset($eventData[$key][$key2]);
                    }
                }
            }
        } else {
            if (is_null($value)) {
                unset($eventData[$key]);
            }
        }
    }

	// set a cookie to prevent sending the event again, using javascript, cookie name "trackman_purchase"
	?>
	<script type="text/javascript">
		window.addEventListener("load", function (event) {
			// Delay execution by 1.5 seconds (1500 milliseconds)
			setTimeout(function() {
				<?php foreach( $trackman_public_keys_array as $public_key ): ?>
					tmfire('<?= $public_key ?>', <?= json_encode($eventData) ?>);
				<?php endforeach; ?>
			}, 1500);

			// Set cookie to expire in 1 day
			document.cookie = "trackman_purchase_<?= $order_id ?>=true;max-age=86400";
		});
	</script>

	<?php
}

function trackman_add_fb_pixel_to_wooc_thankyou() {

	// Get the current URL
    $current_url = $_SERVER['REQUEST_URI'];

    // Check if the URL contains "/order-received"
    if (strpos($current_url, '/order-received') === false) {
		// var_dump("no order received");
        return false;
    } else {
		// var_dump("order received");
	}

	// extract order ID that comes behind "/order-received" for example: http://localhost:10023/checkout/order-received/138
	$order_id = get_order_id_from_url($current_url);
	if( !$order_id ) return;

	if( is_order_from_woofunnels($order_id) ) {
		$step_id = is_order_from_woofunnels($order_id);
		global $wpdb;
		$table_name = $wpdb->prefix . 'bwf_funnels';
		$result = $wpdb->get_results("SELECT * FROM {$table_name} WHERE steps LIKE '%:{$step_id}%'", ARRAY_A);
		if( !$result ) return;
		$result = $result[0];
		$funnel_id = $result['id'];
		$value_arr = get_option( 'trackman_wf_public_keys' );
		$public_keys_arr_string = $value_arr[$funnel_id];
		$trackman_public_keys_array = explode(',', $public_keys_arr_string);
	} else {
		$trackman_public_keys_array = explode( ',', get_option( 'trackman_public_key' ) );
		// skip this if options 'trackman_woocommerce_autosend' is false or null
		if( get_option( 'trackman_woocommerce_autosend' ) == false || get_option( 'trackman_woocommerce_autosend' ) == null ) {
			return;
		}
	}

	// if the cookie exists, do not send the event
	if (isset($_COOKIE['trackman_purchase_'.$order_id])) {
		return;
	}

	// get order object
	$order = wc_get_order( $order_id );
	// var_dump($order_id);
	$firstname = $order->get_billing_first_name() ? $order->get_billing_first_name() : $order->get_shipping_first_name();
	$lastname = $order->get_billing_last_name() ? $order->get_billing_last_name() : $order->get_shipping_last_name();
	$email = $order->get_billing_email();
	$phone = $order->get_billing_phone();
	$city = $order->get_billing_city() ? $order->get_billing_city() : $order->get_shipping_city();
	$state = $order->get_billing_state() ? $order->get_billing_state() : $order->get_shipping_state();
	$postcode = $order->get_billing_postcode() ? $order->get_billing_postcode() : $order->get_shipping_postcode();
	$country = $order->get_billing_country() ? $order->get_billing_country() : $order->get_shipping_country();
	$address = $order->get_billing_address_1() ? $order->get_billing_address_1() : $order->get_shipping_address_1();
	$address2 = $order->get_billing_address_2() ? $order->get_billing_address_2() : $order->get_shipping_address_2();
	$order_total_as_float = floatval($order->get_total());

	$eventData = [
		'event_name' => 'Purchase',
		'event_time' => time(),
		"action_source" => "website",
		"opt_out" => false,
		"event_id" => $eventId,
		'event_source_url' => $event_source_url,
		'user_data' => [
			'client_ip_address' => $_SERVER['REMOTE_ADDR'],
			'client_user_agent' => $_SERVER['HTTP_USER_AGENT'],
			// 'fbc' => $fbc,
			// 'fbp' => $fbp,
			'fn' => $firstname,
			'ln' => $lastname,
			'em' => $email,
			'ph' => $phone,
			'ct' => $city,
			'st' => $state,
			'zp' => $postcode,
			'country' => $country
		],
		'custom_data' => [
			'content_name' => 'Purchase',
			'content_category' => 'ecommerce',
			'content_ids' => '',
			'content_type' => 'product',
			'currency' => get_woocommerce_currency(),
			'value' => $order_total_as_float,
			'num_items' => $order->get_item_count(),
		]
	];

    // loop through $eventData into every level and remove null values
    foreach ($eventData as $key => $value) {
        if (is_array($value)) {
            foreach ($value as $key2 => $value2) {
                if (is_array($value2)) {
                    foreach ($value2 as $key3 => $value3) {
                        if (is_null($value3)) {
                            unset($eventData[$key][$key2][$key3]);
                        }
                    }
                } else {
                    if (is_null($value2)) {
                        unset($eventData[$key][$key2]);
                    }
                }
            }
        } else {
            if (is_null($value)) {
                unset($eventData[$key]);
            }
        }
    }

	// set a cookie to prevent sending the event again, using javascript, cookie name "trackman_purchase"
	?>
	<script type="text/javascript">
		window.addEventListener("load", function (event) {
			setTimeout(function() {
				<?php foreach( $trackman_public_keys_array as $public_key ): ?>
					tmfire('<?= $public_key ?>', <?= json_encode($eventData) ?>);
				<?php endforeach; ?>
			}, 1500);
			// setcookie expire in 1 day
			document.cookie = "trackman_purchase_<?= $order_id ?>=true;max-age=86400";
		});
	</script>
	<?php
}

function get_order_id_from_url($url) {
    $order_id = '';

    // Check if the URL contains "/order-received/"
    if (strpos($url, '/order-received/') !== false) {
        $url_parts = parse_url($url);
        if (isset($url_parts['path'])) {
            $path_parts = explode('/', $url_parts['path']);
            $key = array_search('order-received', $path_parts);
            if ($key !== false && isset($path_parts[$key + 1])) {
                $order_id = $path_parts[$key + 1];
            }
        }
    }

    if (empty($order_id)) {
        return false; // Return false if the order ID is not found
    }

    return $order_id;
}