<?php

function is_order_from_woofunnels($order_id) {
    // Get the WooFunnels funnel ID associated with the order
    $step_id = get_post_meta($order_id, '_wfacp_post_id', true);

    // Check if the funnel ID is set and not empty
    if (!empty($step_id)) {
        return $step_id;
    }

    return false; // Order is created by WooCommerce
}

add_action('wp_footer', 'trackman_add_fb_pixel_to_add_to_cart_woofunnels');
add_action('wp_footer', 'trackman_add_fb_pixel_to_initiatecheckout_woofunnels');
add_action('wp_footer', 'trackman_add_fb_pixel_to_landing_page_woofunnels');

function trackman_add_fb_pixel_to_add_to_cart_woofunnels() {

    // if get_woocommerce_currency() function is not available, return
    if( !function_exists('get_woocommerce_currency') ) return;
    
    $woocommerce_currency = get_woocommerce_currency();
    $wordpress_post_id = get_the_ID();

    // var_dump(get_post_type($wordpress_post_id));

    // check if current post_type is 'wfacp_checkout'
    if (get_post_type($wordpress_post_id) != 'wfacp_checkout') {
        // var_dump("not checkout");
        return;
    } else {
        // var_dump("checkout found");
    }
    
    // query SQL from '(wordpress_prefix)_bwf_funnels' where 'steps' LIKE %($wordpress_post_id)% and get row id
    global $wpdb;
    $table_name = $wpdb->prefix . 'bwf_funnels';
    $result = $wpdb->get_results("SELECT * FROM {$table_name} WHERE steps LIKE '%:{$wordpress_post_id}%'", ARRAY_A);
    if( !$result ) return;
    $result = $result[0];
    $funnel_id = $result['id'];

    // get options from 'trackman_wf_public_keys' where key = $funnel_id
    $value_arr = get_option( 'trackman_wf_public_keys' );
    $public_keys_arr_string = $value_arr[$funnel_id];
    $public_keys_arr = explode(',', $public_keys_arr_string);

    ?>
    <script type='text/javascript'>
        if( typeof eventIsTriggered == 'undefined' )
            var eventIsTriggered = [];

        if( typeof funnelId == 'undefined')
            var funnelId = null;

        if( typeof eventAddToCartIsTriggered == 'undefined' )
        var eventAddToCartIsTriggered = [];
                
        // on document load, find the DOM with class "_wfacp_post_id" and read its "value" attribute
        jQuery(window).on('load', function(){
            var funnelId = document.querySelector("._wfacp_post_id").value;
            console.log("funnelId: ", funnelId);

            var parent = jQuery(this).closest(".wfacp_product_row");
            var dataId = parent.data("id");

            if(jQuery.inArray(dataId, eventAddToCartIsTriggered) !== -1) {
                return;
            }

            // read product price from .woocommerce-Price-amount.amount text() and convert to float
            // var productPrice = parseFloat( jQuery(".mini_cart_wrap_here .order-total .woocommerce-Price-amount.amount").text().replace(/[^0-9-.]/g, '') );

            var productPrice = 0;
            // loop through .wfacp_product_row input[type=radio]:checked or .wfacp_product_row input[type=checkbox]:checked
            // find the closest .product-price .woocommerce-Price-amount bdi:last-child
            // get its HTML and use RegEx to get only float number
            // add each into productPrice
            jQuery(".wfacp_product_row input[type=radio]:checked, .wfacp_product_row input[type=checkbox]:checked").each(function(){
                var parent = jQuery(this).closest(".wfacp_product_row");
                if( parent.find("ins").length > 0 )
                    var productPriceString = parent.find(".product-price ins bdi:last-child").text();
                else
                    var productPriceString = parent.find(".product-price .woocommerce-Price-amount:last-child bdi:last-child").text();

                var productPriceFloat = parseFloat( productPriceString.replace(/[^0-9-.]/g, '') );
                productPrice += productPriceFloat;
            });

            eventAddToCartIsTriggered.push(dataId);
            // if eventAddToCartIsTriggered contains the same data-id, do not send the event
            console.log("eventAddToCartIsTriggered", eventAddToCartIsTriggered);

            var customData = {
                value: productPrice,
                currency: '<?= $woocommerce_currency ?>',
                // content_name: parent.find(".wfacp_product_name_inner").text(),
            };

            var eventObj = {
                event_name: 'AddToCart',
                custom_data: customData,
            };

            <?php foreach($public_keys_arr as $public_key): ?>
                tmfire('<?= $public_key ?>', eventObj);
            <?php endforeach; ?>
        });
        
    </script>
    <?php
}

function trackman_add_fb_pixel_to_initiatecheckout_woofunnels() {

    // if get_woocommerce_currency() function is not available, return
    if( !function_exists('get_woocommerce_currency') ) return;

    $wordpress_post_id = get_the_ID();
    $woocommerce_currency = get_woocommerce_currency();
    
    // check if current post_type is 'wfacp_checkout'
    if (get_post_type($wordpress_post_id) != 'wfacp_checkout') {
        return;
    }

    // query SQL from '(wordpress_prefix)_bwf_funnels' where 'steps' LIKE %($wordpress_post_id)% and get row id
    global $wpdb;
    $table_name = $wpdb->prefix . 'bwf_funnels';
    $result = $wpdb->get_results("SELECT * FROM {$table_name} WHERE steps LIKE '%:{$wordpress_post_id}%'", ARRAY_A);
    if( !$result ) return;
    $result = $result[0];
    $funnel_id = $result['id'];

    // get options from 'trackman_wf_public_keys' where key = $funnel_id
    $value_arr = get_option( 'trackman_wf_public_keys' );
    $public_keys_arr_string = $value_arr[$funnel_id];
    $public_keys_arr = explode(',', $public_keys_arr_string);

    ?>
    <script type='text/javascript'>
        if( typeof eventInitiateCheckoutIsTriggered == 'undefined' )
            var eventInitiateCheckoutIsTriggered = [];

        if( typeof funnelId == 'undefined')
            var funnelId = null;

        // on document load, find the DOM with class "_wfacp_post_id" and read its "value" attribute
        document.addEventListener("DOMContentLoaded", function(event) {
            var funnelId = document.querySelector("._wfacp_post_id").value;
        });

        jQuery(document).on("focus", ".wfacp-form-control", function(event) {
            var parent = jQuery(this).closest(".wfacp_product_row");
            var dataId = parent.data("id");

            if(jQuery.inArray(dataId, eventInitiateCheckoutIsTriggered) !== -1) {
                return;
            }

            // read product price from .woocommerce-Price-amount.amount text() and convert to float
            // var productPrice = parseFloat( jQuery(".mini_cart_wrap_here .order-total .woocommerce-Price-amount.amount").text().replace(/[^0-9-.]/g, '') );

            var productPrice = 0;
            // loop through .wfacp_product_row input[type=radio]:checked or .wfacp_product_row input[type=checkbox]:checked
            // find the closest .product-price .woocommerce-Price-amount bdi:last-child
            // get its HTML and use RegEx to get only float number
            // add each into productPrice
            jQuery(".wfacp_product_row input[type=radio]:checked, .wfacp_product_row input[type=checkbox]:checked").each(function(){
                var parent = jQuery(this).closest(".wfacp_product_row");
                if( parent.find("ins").length > 0 )
                    var productPriceString = parent.find(".product-price ins bdi:last-child").text();
                else
                    var productPriceString = parent.find(".product-price .woocommerce-Price-amount:last-child bdi:last-child").text();

                var productPriceFloat = parseFloat( productPriceString.replace(/[^0-9-.]/g, '') );
                productPrice += productPriceFloat;
            });

            eventInitiateCheckoutIsTriggered.push(dataId);
            // if eventInitiateCheckoutIsTriggered contains the same data-id, do not send the event

            var customData = {
                value: productPrice,
                currency: '<?= $woocommerce_currency ?>',
                // content_name: parent.find(".wfacp_product_name_inner").text(),
            };

            var eventObj = {
                event_name: 'InitiateCheckout',
                custom_data: customData,
            };

            <?php foreach($public_keys_arr as $public_key): ?>
                tmfire('<?= $public_key ?>', eventObj);
            <?php endforeach; ?>
        });

    </script>
    <?php
}

function trackman_add_fb_pixel_to_landing_page_woofunnels() {
    $wordpress_post_id = get_the_ID();
    
    // check if current post_type is 'wfacp_landing'
    if (get_post_type($wordpress_post_id) != 'wffn_landing') {
        return;
    } else

    // query SQL from '(wordpress_prefix)_bwf_funnels' where 'steps' LIKE %($wordpress_post_id)% and get row id
    global $wpdb;
    $table_name = $wpdb->prefix . 'bwf_funnels';
    $result = $wpdb->get_results("SELECT * FROM {$table_name} WHERE steps LIKE '%:{$wordpress_post_id}%'", ARRAY_A);
    if( !$result ) return;
    $result = $result[0];
    $funnel_id = $result['id'];

    // get options from 'trackman_wf_public_keys' where key = $funnel_id
    $value_arr = get_option( 'trackman_wf_public_keys' );
    $public_keys_arr_string = $value_arr[$funnel_id];
    $public_keys_arr = explode(',', $public_keys_arr_string);
    ?>
        <script type='text/javascript'>
            var eventObj = {
                event_name: 'ViewContent'
            };
            jQuery(window).on('load', function(){
                <?php foreach($public_keys_arr as $public_key): ?>
                    tmfire('<?= $public_key ?>', eventObj);
                <?php endforeach; ?>
            });
        </script>
    <?php
}